page    ,133
%title  "Activity 9 Test Program"
comment *
Ŀ
 From "Build Your Own Computer: How to Construct an 8088 Based             
       Single Board Microcomputer" by Walter Fuller  (c)1995 Delmar        

*
.model tiny
.code
jumps

;Test program for activity 9

;   I/O port and configuration values for 
;   the TJC88 computer.


ppi_port_b      equ     25h
ppi_ctrl_port   equ     27h

int_icw1_port   equ     2ch
int_icw2_port   equ     2dh
int_icw4_port   equ     2dh
int_ocw1_port   equ     2dh

int_icw1_word   equ     00011011b       ;level triggered, single mode
int_icw2_word   equ     01011000b       ;IR0 type number = 58h
int_icw4_word   equ     00000011b       ;8088 mode
int_ocw1_word   equ     11111110b       ;unmask IR0, IR1-IR7 masked

        org     8000h

main    proc

        cli
        mov     ax,0                    ;all segments to 0
        mov     ds,ax
        mov     es,ax
        mov     ss,ax

        mov     ax,1000h                ;stack
        mov     sp,ax

        mov     al,10011001b            ;configuration word for the 8255
                                        ;both group A and B = mode 0
                                        ;port A = input
                                        ;port B = output
                                        ;port C = input
        out     ppi_ctrl_port,al        ;send configuration word to 8255
        
        mov     si,(58h*4)              ;install ISR for type 58h
        mov     dx,offset pulse         ;address of pulse subroutine (ISR)
        mov     word ptr[si],dx         ;store the IP address
        add     si,2
        mov     word ptr[si],0          ;store the CS address

        mov     al,int_icw1_word        ;initialize the 8259
        out     int_icw1_port,al
        mov     al,int_icw2_word
        out     int_icw2_port,al
        mov     al,int_icw4_word
        out     int_icw4_port,al

        mov     al,int_ocw1_word        ;output control word to unmask IR0
        out     int_ocw1_port,al
        
        sti                             ;enable system interrupts

here:   jmp     here                    ;wait for interrupt

main    endp

pulse   proc
        cli                             ;disable interrupts - important!
again:
        mov     al,0                    ;all lines to logic low
        out     ppi_port_b,al
        call    delay                   ;slow it down a bit
        mov     al,0ffh                 ;now all lines to logic high
        out     ppi_port_b,al
        call    delay                   ;slow one more time
        iret                            ;exit subroutine

pulse   endp

delay   proc
        push    cx
        mov     cx,4000h                ;delay value
delay5:
        loop    delay5                  ;count it down
        pop     cx
        ret
delay   endp

        org     0fff0h
        
        db      0eah,0,80h,0,0          ;opcodes for far jump to 08000h
                                        ;go there to start program
        
end     main


